# Effects

effect give @a minecraft:saturation 1000000 127 true
effect give @a minecraft:instant_health 1000000 99 true
effect give @a minecraft:weakness 1000000 127 true

bossbar set map:game.turn players @a



# Player Logging

execute as @a if score @s map.leave matches 1.. run tag @s remove game.player.joined
execute as @a[tag=!game.player.joined] run team join lobby @s
execute as @a[tag=!game.player.joined] run scoreboard players reset @s map.gameid
execute as @a[tag=!game.player.joined] run scoreboard players set @s map.state 0
execute as @a[tag=!game.player.joined] run tp @s 0 0 -14 0 0
tag @a add game.player.joined
scoreboard players set @a map.leave 0



# Gamestate

execute unless score *map.gamestate map.state matches 0.. run scoreboard players set *map.gamestate map.state 0

execute if score *map.gamestate map.state matches 0 run function map:nogame/tick
execute if score *map.gamestate map.state matches 1 run function map:game/tick



# Teams

execute as @a[team=red] unless data entity @s Inventory[{Slot:103b,tag:{map:{hat:"red"}}}] run item replace entity @s armor.head with minecraft:leather_helmet{map:{hat:"red"},display:{color:16733525,Name:"[{\"text\":\"RED\",\"color\":\"red\",\"bold\":true,\"italic\":false}]"}}
execute as @a[team=yellow] unless data entity @s Inventory[{Slot:103b,tag:{map:{hat:"yellow"}}}] run item replace entity @s armor.head with minecraft:leather_helmet{map:{hat:"yellow"},display:{color:16777045,Name:"[{\"text\":\"YELLOW\",\"color\":\"yellow\",\"bold\":true,\"italic\":false}]"}}
execute as @a[team=green] unless data entity @s Inventory[{Slot:103b,tag:{map:{hat:"green"}}}] run item replace entity @s armor.head with minecraft:leather_helmet{map:{hat:"green"},display:{color:5635925,Name:"[{\"text\":\"GREEN\",\"color\":\"green\",\"bold\":true,\"italic\":false}]"}}
execute as @a[team=blue] unless data entity @s Inventory[{Slot:103b,tag:{map:{hat:"blue"}}}] run item replace entity @s armor.head with minecraft:leather_helmet{map:{hat:"blue"},display:{color:5592575,Name:"[{\"text\":\"BLUE\",\"color\":\"blue\",\"bold\":true,\"italic\":false}]"}}
item replace entity @a[team=lobby] armor.head with minecraft:air
item replace entity @a armor.chest with minecraft:air



# Falling off the map

execute as @a store result score @s map.pos.y run data get entity @s Pos[1] 1
execute as @a if score @s map.pos.y matches ..-2 run tp @s 0 0 -14 0 0
execute as @a if score @s map.pos.y matches ..-2 at @s run playsound minecraft:entity.enderman.teleport master @s ~ ~ ~ 1 0



# Parkour

execute as @a[tag=lobby.parkour] at @s positioned ~0.3 ~-0.01 ~0.3 unless block ~ ~ ~ minecraft:air unless block ~ ~ ~ minecraft:red_concrete_powder unless block ~ ~ ~ minecraft:yellow_concrete_powder unless block ~ ~ ~ minecraft:lime_concrete_powder unless block ~ ~ ~ minecraft:light_blue_concrete_powder unless block ~ ~ ~ minecraft:magenta_concrete_powder run playsound minecraft:block.note_block.didgeridoo master @s ~ ~ ~ 1 1
execute as @a[tag=lobby.parkour] at @s positioned ~0.3 ~-0.01 ~0.3 unless block ~ ~ ~ minecraft:air unless block ~ ~ ~ minecraft:red_concrete_powder unless block ~ ~ ~ minecraft:yellow_concrete_powder unless block ~ ~ ~ minecraft:lime_concrete_powder unless block ~ ~ ~ minecraft:light_blue_concrete_powder unless block ~ ~ ~ minecraft:magenta_concrete_powder run tag @s remove lobby.parkour
execute as @a[tag=lobby.parkour] at @s positioned ~-0.3 ~-0.01 ~0.3 unless block ~ ~ ~ minecraft:air unless block ~ ~ ~ minecraft:red_concrete_powder unless block ~ ~ ~ minecraft:yellow_concrete_powder unless block ~ ~ ~ minecraft:lime_concrete_powder unless block ~ ~ ~ minecraft:light_blue_concrete_powder unless block ~ ~ ~ minecraft:magenta_concrete_powder run playsound minecraft:block.note_block.didgeridoo master @s ~ ~ ~ 1 1
execute as @a[tag=lobby.parkour] at @s positioned ~-0.3 ~-0.01 ~0.3 unless block ~ ~ ~ minecraft:air unless block ~ ~ ~ minecraft:red_concrete_powder unless block ~ ~ ~ minecraft:yellow_concrete_powder unless block ~ ~ ~ minecraft:lime_concrete_powder unless block ~ ~ ~ minecraft:light_blue_concrete_powder unless block ~ ~ ~ minecraft:magenta_concrete_powder run tag @s remove lobby.parkour
execute as @a[tag=lobby.parkour] at @s positioned ~0.3 ~-0.01 ~-0.3 unless block ~ ~ ~ minecraft:air unless block ~ ~ ~ minecraft:red_concrete_powder unless block ~ ~ ~ minecraft:yellow_concrete_powder unless block ~ ~ ~ minecraft:lime_concrete_powder unless block ~ ~ ~ minecraft:light_blue_concrete_powder unless block ~ ~ ~ minecraft:magenta_concrete_powder run playsound minecraft:block.note_block.didgeridoo master @s ~ ~ ~ 1 1
execute as @a[tag=lobby.parkour] at @s positioned ~0.3 ~-0.01 ~-0.3 unless block ~ ~ ~ minecraft:air unless block ~ ~ ~ minecraft:red_concrete_powder unless block ~ ~ ~ minecraft:yellow_concrete_powder unless block ~ ~ ~ minecraft:lime_concrete_powder unless block ~ ~ ~ minecraft:light_blue_concrete_powder unless block ~ ~ ~ minecraft:magenta_concrete_powder run tag @s remove lobby.parkour
execute as @a[tag=lobby.parkour] at @s positioned ~-0.3 ~-0.01 ~-0.3 unless block ~ ~ ~ minecraft:air unless block ~ ~ ~ minecraft:red_concrete_powder unless block ~ ~ ~ minecraft:yellow_concrete_powder unless block ~ ~ ~ minecraft:lime_concrete_powder unless block ~ ~ ~ minecraft:light_blue_concrete_powder unless block ~ ~ ~ minecraft:magenta_concrete_powder run playsound minecraft:block.note_block.didgeridoo master @s ~ ~ ~ 1 1
execute as @a[tag=lobby.parkour] at @s positioned ~-0.3 ~-0.01 ~-0.3 unless block ~ ~ ~ minecraft:air unless block ~ ~ ~ minecraft:red_concrete_powder unless block ~ ~ ~ minecraft:yellow_concrete_powder unless block ~ ~ ~ minecraft:lime_concrete_powder unless block ~ ~ ~ minecraft:light_blue_concrete_powder unless block ~ ~ ~ minecraft:magenta_concrete_powder run tag @s remove lobby.parkour

execute positioned 7.0 0 -16.0 as @a[dx=1,dy=0.25,dz=1,tag=!lobby.parkour] run scoreboard players set @s map.time 0
execute positioned 7.0 0 -16.0 as @a[dx=1,dy=0.25,dz=1,tag=!lobby.parkour] at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 1 1
execute positioned 7.0 0 -16.0 as @a[dx=1,dy=0.25,dz=1,tag=!lobby.parkour] run tag @s add lobby.parkour

execute positioned 10.0 13 15.0 as @a[dx=1,dy=0.25,dz=1,tag=lobby.parkour] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 1 1
execute positioned 10.0 13 15.0 as @a[dx=1,dy=0.25,dz=1,tag=lobby.parkour] run tag @s remove lobby.parkour

execute as @a[tag=lobby.parkour] run scoreboard players add @s map.time 1

execute as @a[tag=lobby.parkour] store result score @s map.math1 run scoreboard players get @s map.time
execute as @a[tag=lobby.parkour] run scoreboard players set @s map.math4 1200
execute as @a[tag=lobby.parkour] run scoreboard players operation @s map.math1 /= @s map.math4

execute as @a[tag=lobby.parkour] store result score @s map.math2 run scoreboard players get @s map.time
execute as @a[tag=lobby.parkour] run scoreboard players set @s map.math4 20
execute as @a[tag=lobby.parkour] run scoreboard players operation @s map.math2 /= @s map.math4
execute as @a[tag=lobby.parkour] run scoreboard players set @s map.math4 60
execute as @a[tag=lobby.parkour] run scoreboard players operation @s map.math2 %= @s map.math4

execute as @a[tag=lobby.parkour] store result score @s map.math3 run scoreboard players get @s map.time
execute as @a[tag=lobby.parkour] run scoreboard players set @s map.math4 2
execute as @a[tag=lobby.parkour] run scoreboard players operation @s map.math3 /= @s map.math4
execute as @a[tag=lobby.parkour] run scoreboard players set @s map.math4 10
execute as @a[tag=lobby.parkour] run scoreboard players operation @s map.math3 %= @s map.math4

execute as @a[tag=lobby.parkour] run title @s actionbar [{"score":{"name":"@s","objective":"map.math1"},"color":"light_purple","bold":true},{"text":":","color":"dark_purple","bold":false},{"score":{"name":"@s","objective":"map.math2"},"color":"light_purple","bold":true},{"text":".","color":"dark_purple","bold":false},{"score":{"name":"@s","objective":"map.math3"},"color":"light_purple","bold":true}]



# Tutorial

scoreboard players add *map.tutorial map.time 1

execute if score *map.tutorial map.time matches 140.. run scoreboard players set *map.tutorial map.time 0



# Tutorial / Objective

execute if score *map.tutorial map.time matches 0 run setblock 15 0 -9 minecraft:lime_wool
execute if score *map.tutorial map.time matches 0 run fill 15 -1 -9 14 -1 -9 minecraft:lime_concrete

execute if score *map.tutorial map.time matches 50 run setblock 15 0 -9 minecraft:air
execute if score *map.tutorial map.time matches 50 run fill 15 -1 -9 14 -1 -9 minecraft:white_concrete

execute if score *map.tutorial map.time matches 70 run setblock 15 0 -9 minecraft:lime_wool
execute if score *map.tutorial map.time matches 70 run fill 15 -1 -9 14 -1 -9 minecraft:lime_concrete

execute if score *map.tutorial map.time matches 120 run setblock 15 0 -9 minecraft:air
execute if score *map.tutorial map.time matches 120 run fill 15 -1 -9 14 -1 -9 minecraft:white_concrete





# Tutorial / Turns

execute if score *map.tutorial map.time matches 0 run setblock 15 0 -3 minecraft:red_concrete
execute if score *map.tutorial map.time matches 40 run setblock 15 0 -3 minecraft:air

execute if score *map.tutorial map.time matches 80 run setblock 13 0 -5 minecraft:red_stained_glass
execute if score *map.tutorial map.time matches 80 run setblock 13 -1 -5 minecraft:red_concrete
execute if score *map.tutorial map.time matches 120 run setblock 13 0 -5 minecraft:air
execute if score *map.tutorial map.time matches 120 run setblock 13 -1 -5 minecraft:white_concrete



# Tutorial / Contested

execute if score *map.tutorial map.time matches 0 run setblock 14 0 -1 minecraft:red_wool
execute if score *map.tutorial map.time matches 0 run fill 15 -1 -1 13 -1 -1 minecraft:red_concrete
execute if score *map.tutorial map.time matches 0 run setblock 14 -1 0 minecraft:red_concrete
execute if score *map.tutorial map.time matches 20 run setblock 14 0 1 minecraft:lime_wool
execute if score *map.tutorial map.time matches 20 run fill 15 -1 1 13 -1 1 minecraft:lime_concrete
execute if score *map.tutorial map.time matches 20 run setblock 14 -1 0 minecraft:gray_concrete
execute if score *map.tutorial map.time matches 40 run fill 15 -1 -1 13 -1 1 minecraft:white_concrete
execute if score *map.tutorial map.time matches 40 run fill 15 0 -1 13 0 1 minecraft:air

execute if score *map.tutorial map.time matches 60 run setblock 14 0 0 minecraft:yellow_wool
execute if score *map.tutorial map.time matches 60 run fill 13 -1 0 15 -1 0 minecraft:yellow_concrete
execute if score *map.tutorial map.time matches 60 run fill 14 -1 -1 14 -1 1 minecraft:yellow_concrete
execute if score *map.tutorial map.time matches 80 run setblock 15 0 -1 minecraft:lime_stained_glass
execute if score *map.tutorial map.time matches 80 run setblock 15 -1 -1 minecraft:lime_concrete
execute if score *map.tutorial map.time matches 100 run setblock 13 0 1 minecraft:lime_stained_glass
execute if score *map.tutorial map.time matches 100 run setblock 13 -1 1 minecraft:lime_concrete
execute if score *map.tutorial map.time matches 100 run fill 13 -1 0 15 -1 0 minecraft:white_concrete
execute if score *map.tutorial map.time matches 100 run fill 14 -1 -1 14 -1 1 minecraft:white_concrete
execute if score *map.tutorial map.time matches 100 run setblock 14 -1 0 minecraft:lime_concrete
execute if score *map.tutorial map.time matches 100 run setblock 14 0 0 minecraft:air
execute if score *map.tutorial map.time matches 100 run particle minecraft:block minecraft:yellow_wool 14 0.5 0 0.125 0.125 0.125 0 25 normal @a
execute if score *map.tutorial map.time matches 120 run fill 15 -1 -1 13 -1 1 minecraft:white_concrete
execute if score *map.tutorial map.time matches 120 run fill 15 0 -1 13 0 1 minecraft:air



# Tutorial / Line

execute if score *map.tutorial map.time matches 0 run setblock 15 0 3 minecraft:light_blue_stained_glass
execute if score *map.tutorial map.time matches 0 run setblock 15 -1 3 minecraft:light_blue_concrete
execute if score *map.tutorial map.time matches 20 run setblock 13 0 5 minecraft:light_blue_stained_glass
execute if score *map.tutorial map.time matches 20 run setblock 13 -1 5 minecraft:light_blue_concrete
execute if score *map.tutorial map.time matches 20 run setblock 14 -1 4 minecraft:light_blue_concrete
execute if score *map.tutorial map.time matches 40 run fill 15 -1 3 13 -1 5 minecraft:white_concrete
execute if score *map.tutorial map.time matches 40 run fill 15 0 3 13 0 5 minecraft:air

execute if score *map.tutorial map.time matches 80 run setblock 15 0 4 minecraft:light_blue_stained_glass
execute if score *map.tutorial map.time matches 80 run setblock 15 -1 4 minecraft:light_blue_concrete
execute if score *map.tutorial map.time matches 100 run setblock 13 0 4 minecraft:light_blue_stained_glass
execute if score *map.tutorial map.time matches 100 run setblock 13 -1 4 minecraft:light_blue_concrete
execute if score *map.tutorial map.time matches 100 run setblock 14 -1 4 minecraft:light_blue_concrete
execute if score *map.tutorial map.time matches 120 run fill 15 -1 3 13 -1 5 minecraft:white_concrete
execute if score *map.tutorial map.time matches 120 run fill 15 0 3 13 0 5 minecraft:air



# Tutorial / Dot

execute if score *map.tutorial map.time matches 0 run setblock 14 0 8 minecraft:yellow_wool
execute if score *map.tutorial map.time matches 0 run fill 13 -1 8 15 -1 8 minecraft:yellow_concrete
execute if score *map.tutorial map.time matches 0 run fill 14 -1 7 14 -1 9 minecraft:yellow_concrete

execute if score *map.tutorial map.time matches 50 run fill 13 -1 7 15 -1 9 minecraft:white_concrete
execute if score *map.tutorial map.time matches 50 run fill 13 0 7 15 0 9 minecraft:air

execute if score *map.tutorial map.time matches 70 run setblock 14 0 8 minecraft:yellow_wool
execute if score *map.tutorial map.time matches 70 run fill 13 -1 8 15 -1 8 minecraft:yellow_concrete
execute if score *map.tutorial map.time matches 70 run fill 14 -1 7 14 -1 9 minecraft:yellow_concrete

execute if score *map.tutorial map.time matches 120 run fill 13 -1 7 15 -1 9 minecraft:white_concrete
execute if score *map.tutorial map.time matches 120 run fill 13 0 7 15 0 9 minecraft:air
